/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/04/30
* Description        : Main program body.
*******************************************************************************/

// main֮ǰļstatup_ch32v10x.SѾSystemInit()ϵͳʱӳʼ72MHZ
// SystemInit()system_ch32v10x.cж
// û޸ϵͳʱӣбд޸,½̳Ҫûαд޸ϵͳʱԼͨPA8ʱ

#include "debug.h"
#include "clk.h"

#define HSI      0   //HSI
#define HSI_1_2  1   //HSI/2

#define PLL_Source   HSI
//#define PLL_Source   HSI_1_2

//  ʱʹòͬϵͳʱӣʱһ
void Delay(__IO uint32_t nCount)
{
    for(; nCount != 0; nCount--);
}

void MCO_GPIO_Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure;
    // GPIOAʱ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);

    // ѡGPIO8
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;

    //Ϊù
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;

    //IOķתΪ50M
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;

    // ʼGPIOA8
    GPIO_Init(GPIOA, &GPIO_InitStructure);
}

void LED_Init(void)
{

    GPIO_InitTypeDef  GPIO_InitStructure;                     //һGPIO_InitTypeDef͵Ľṹ

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);     //ʹLEDصGPIO˿ʱ

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1;      //GPIO
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;          //GPIOģʽΪ
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;         //GPIOٶ
    GPIO_Init(GPIOA, &GPIO_InitStructure);                    //ÿ⺯ʼGPIOA

    GPIO_SetBits(GPIOA,GPIO_Pin_0|GPIO_Pin_1);                //ߵƽ

}

/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Return         : None
*******************************************************************************/
int main(void)
{

    HSI_SetSysClock(RCC_PLLMul_9);

    USART_Printf_Init(115200);
	MCO_GPIO_Init();
	LED_Init();

	printf("This is HSE&HSI example\r\n");

    // ϵͳʱӣҪ޸ģCH32V103߿Ϊ80MHͨʹ72MΪĬ
    // SYSCLK = 8M * RCC_PLLMul_x, x:[2,3,...16]
    //HSE_SetSysClock(RCC_PLLMul_9);


    // MCOʱӣʾPA8ʱź
    // MCOHSE,HSI,PLLCLK/2,SYSCLK
    //RCC_MCOConfig(RCC_MCO_HSE);             // 8M
    //RCC_MCOConfig(RCC_MCO_HSI);             // 8M
    //RCC_MCOConfig(RCC_MCO_PLLCLK_Div2);     // 36M
    RCC_MCOConfig(RCC_MCO_SYSCLK);            // 72M

    printf("This is HSE&HSI example\r\n");

    while (1)
    {
        GPIO_SetBits(GPIOA,GPIO_Pin_0|GPIO_Pin_1);        // 
        Delay(0x0FFFFF);
        GPIO_ResetBits(GPIOA,GPIO_Pin_0|GPIO_Pin_1);      // 
        Delay(0x0FFFFF);
    }
}

